require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_POWERPC_ATOMIC_H_)) {
    eval 'sub _POWERPC_ATOMIC_H_ () {1;}' unless defined(&_POWERPC_ATOMIC_H_);
    if(defined(&_KERNEL)) {
	eval 'sub atomic_setbits_int {
	    my($uip,$v) = @_;
    	    eval q({ my $tmp;  &__asm  &volatile ( \\"1:	lwarx	%0, 0, %2	\\\\n\\" \\"	or	%0, %1, %0	\\\\n\\" \\"	stwcx.	%0, 0, %2	\\\\n\\" \\"	bne-	1b		\\\\n\\" \\"	sync\\" : \\"=&r\\" ( $tmp) : \\"r\\" ($v), \\"r\\" ($uip) : \\"cc\\", \\"memory\\"); });
	}' unless defined(&atomic_setbits_int);
	eval 'sub atomic_clearbits_int {
	    my($uip,$v) = @_;
    	    eval q({ my $tmp;  &__asm  &volatile ( \\"1:	lwarx	%0, 0, %2	\\\\n\\" \\"	andc	%0, %0, %1	\\\\n\\" \\"	stwcx.	%0, 0, %2	\\\\n\\" \\"	bne-	1b		\\\\n\\" \\"	sync\\" : \\"=&r\\" ( $tmp) : \\"r\\" ($v), \\"r\\" ($uip) : \\"cc\\", \\"memory\\"); });
	}' unless defined(&atomic_clearbits_int);
	eval 'sub atomic_cas_uint {
	    my($_p, $_o, $_n) = @_;
    	    eval q( &_atomic_cas_uint(($_p), ($_o), ($_n)));
	}' unless defined(&atomic_cas_uint);
	eval 'sub atomic_cas_ulong {
	    my($_p, $_o, $_n) = @_;
    	    eval q( &_atomic_cas_ulong(($_p), ($_o), ($_n)));
	}' unless defined(&atomic_cas_ulong);
	eval 'sub atomic_cas_ptr {
	    my($_p, $_o, $_n) = @_;
    	    eval q( &_atomic_cas_ptr(($_p), ($_o), ($_n)));
	}' unless defined(&atomic_cas_ptr);
	eval 'sub atomic_swap_uint {
	    my($_p, $_v) = @_;
    	    eval q( &_atomic_swap_uint(($_p), ($_v)));
	}' unless defined(&atomic_swap_uint);
	eval 'sub atomic_swap_ulong {
	    my($_p, $_v) = @_;
    	    eval q( &_atomic_swap_ulong(($_p), ($_v)));
	}' unless defined(&atomic_swap_ulong);
	eval 'sub atomic_swap_ptr {
	    my($_p, $_v) = @_;
    	    eval q( &_atomic_swap_ptr(($_p), ($_v)));
	}' unless defined(&atomic_swap_ptr);
	eval 'sub atomic_add_int_nv {
	    my($_p, $_v) = @_;
    	    eval q( &_atomic_add_int_nv(($_p), ($_v)));
	}' unless defined(&atomic_add_int_nv);
	eval 'sub atomic_add_long_nv {
	    my($_p, $_v) = @_;
    	    eval q( &_atomic_add_long_nv(($_p), ($_v)));
	}' unless defined(&atomic_add_long_nv);
	eval 'sub atomic_sub_int_nv {
	    my($_p, $_v) = @_;
    	    eval q( &_atomic_sub_int_nv(($_p), ($_v)));
	}' unless defined(&atomic_sub_int_nv);
	eval 'sub atomic_sub_long_nv {
	    my($_p, $_v) = @_;
    	    eval q( &_atomic_sub_long_nv(($_p), ($_v)));
	}' unless defined(&atomic_sub_long_nv);
	eval 'sub atomic_inc_int_nv {
	    my($_p) = @_;
    	    eval q( &_atomic_addic_int_nv(($_p), 1));
	}' unless defined(&atomic_inc_int_nv);
	eval 'sub atomic_dec_int_nv {
	    my($_p) = @_;
    	    eval q( &_atomic_addic_int_nv(($_p), -1));
	}' unless defined(&atomic_dec_int_nv);
	eval 'sub atomic_inc_long_nv {
	    my($_p) = @_;
    	    eval q( &_atomic_addic_long_nv(($_p), 1));
	}' unless defined(&atomic_inc_long_nv);
	eval 'sub atomic_dec_long_nv {
	    my($_p) = @_;
    	    eval q( &_atomic_addic_long_nv(($_p), -1));
	}' unless defined(&atomic_dec_long_nv);
	eval 'sub __membar {
	    my($_f) = @_;
    	    eval q( &do {  &__asm  &__volatile($_f ::: \\"memory\\"); }  &while (0));
	}' unless defined(&__membar);
	if(defined(&MULTIPROCESSOR)) {
	    eval 'sub membar_enter () {
	        eval q( &__membar(\\"isync\\"));
	    }' unless defined(&membar_enter);
	    eval 'sub membar_exit () {
	        eval q( &__membar(\\"sync\\"));
	    }' unless defined(&membar_exit);
	    eval 'sub membar_producer () {
	        eval q( &__membar(\\"sync\\"));
	    }' unless defined(&membar_producer);
	    eval 'sub membar_consumer () {
	        eval q( &__membar(\\"isync\\"));
	    }' unless defined(&membar_consumer);
	    eval 'sub membar_sync () {
	        eval q( &__membar(\\"sync\\"));
	    }' unless defined(&membar_sync);
	} else {
	    eval 'sub membar_enter () {
	        eval q( &__membar(\\"\\"));
	    }' unless defined(&membar_enter);
	    eval 'sub membar_exit () {
	        eval q( &__membar(\\"\\"));
	    }' unless defined(&membar_exit);
	    eval 'sub membar_producer () {
	        eval q( &__membar(\\"\\"));
	    }' unless defined(&membar_producer);
	    eval 'sub membar_consumer () {
	        eval q( &__membar(\\"\\"));
	    }' unless defined(&membar_consumer);
	    eval 'sub membar_sync () {
	        eval q( &__membar(\\"\\"));
	    }' unless defined(&membar_sync);
	}
    }
}
1;
